-- Sonic Freedom Air Dash 
-- Prototype by Tatsuru
-- Finished by MotdSpork
freeslot("S_PLAY_ROLL1_1", "S_PLAY_ROLL1_2" , "S_PLAY_ROLL1_3", "S_PLAY_ROLL1_4")
freeslot("S_PLAY_ROLL2_1", "S_PLAY_ROLL2_2" , "S_PLAY_ROLL2_3", "S_PLAY_ROLL2_4")
freeslot("S_PLAY_ROLL3_1", "S_PLAY_ROLL3_2" , "S_PLAY_ROLL3_3", "S_PLAY_ROLL3_4")
freeslot("S_PLAY_ROLL4_1", "S_PLAY_ROLL4_2" , "S_PLAY_ROLL4_3", "S_PLAY_ROLL4_4")
freeslot("sfx_spnwnd", "sfx_tdash", "sfx_plchrg", "sfx_plrles", "sfx_tcurl")

sfxinfo[sfx_plrles].caption = "Peelout"
sfxinfo[sfx_plchrg].caption = "Peeling"
sfxinfo[sfx_spnwnd].caption = "Bullet Charge"
sfxinfo[sfx_tdash].caption = "Release"
sfxinfo[sfx_tcurl].caption = "Re-Curl"

states[S_PLAY_ROLL1_1] = {SPR_PLAY, SPR2_ROLL_1, 5, nil, 0, 0, S_PLAY_ROLL1_2}
states[S_PLAY_ROLL1_2] = {SPR_PLAY, SPR2_ROLL_2, 4, nil, 0, 0, S_PLAY_ROLL1_3}
states[S_PLAY_ROLL1_3] = {SPR_PLAY, SPR2_ROLL_3, 4, nil, 0, 0, S_PLAY_ROLL1_4}
states[S_PLAY_ROLL1_4] = {SPR_PLAY, SPR2_ROLL_4, 3, nil, 0, 0, S_PLAY_ROLL2_1}
states[S_PLAY_ROLL2_1] = {SPR_PLAY, SPR2_ROLL_1, 3, nil, 0, 0, S_PLAY_ROLL2_2}
states[S_PLAY_ROLL2_2] = {SPR_PLAY, SPR2_ROLL_2, 3, nil, 0, 0, S_PLAY_ROLL2_3}
states[S_PLAY_ROLL2_3] = {SPR_PLAY, SPR2_ROLL_3, 2, nil, 0, 0, S_PLAY_ROLL2_4}
states[S_PLAY_ROLL2_4] = {SPR_PLAY, SPR2_ROLL_4, 2, nil, 0, 0, S_PLAY_ROLL3_1}
states[S_PLAY_ROLL3_1] = {SPR_PLAY, SPR2_ROLL_1, 2, nil, 0, 0, S_PLAY_ROLL3_2}
states[S_PLAY_ROLL3_2] = {SPR_PLAY, SPR2_ROLL_2, 2, nil, 0, 0, S_PLAY_ROLL3_3}
states[S_PLAY_ROLL3_3] = {SPR_PLAY, SPR2_ROLL_3, 1, nil, 0, 0, S_PLAY_ROLL3_4}
states[S_PLAY_ROLL3_4] = {SPR_PLAY, SPR2_ROLL_4, 1, nil, 0, 0, S_PLAY_ROLL4_1}
states[S_PLAY_ROLL4_1] = {SPR_PLAY, SPR2_ROLL_1, 1, nil, 0, 0, S_PLAY_ROLL4_2}
states[S_PLAY_ROLL4_2] = {SPR_PLAY, SPR2_ROLL_2, 1, nil, 0, 0, S_PLAY_ROLL4_3}
states[S_PLAY_ROLL4_3] = {SPR_PLAY, SPR2_ROLL_3, 1, nil, 0, 0, S_PLAY_ROLL4_4}
states[S_PLAY_ROLL4_4] = {SPR_PLAY, SPR2_ROLL_4, 1, nil, 0, 0, S_PLAY_ROLL4_1}

local function GetFlippedZ(mo)
	if P_MobjFlip(mo) == 1
		return mo.height/4
	elseif P_MobjFlip(mo) == -1
		return -mo.height/4
	end
end

local function SpawnDashAim(mo)
	if mo.player.freeaim == 0
		for i = 1, 13
			local freedomaim = P_SpawnMobjFromMobj(mo, mo.x+mo.momx, mo.y+mo.momy, mo.z, MT_THOK)
			freedomaim.color = mo.color
			freedomaim.scale = mo.scale/2
			freedomaim.tics = 2
			freedomaim.angle = mo.angle
			freedomaim.momx = mo.momx
			freedomaim.momy = mo.momy
			freedomaim.frame = freedomaim.frame|FF_TRANS70
			
			local dist = 7*i
			local vangle = cos(FixedAngle(mo.player.revaiming)*P_MobjFlip(mo))
			
			local x = mo.x + FixedMul(dist * cos(mo.angle), vangle)
			local y = mo.y + FixedMul(dist * sin(mo.angle), vangle)
			local z = mo.z + GetFlippedZ(mo) + dist * sin(FixedAngle(mo.player.revaiming))
			P_SetOrigin(freedomaim, x, y, z)
		end
	else
		for i = 1, 13
			local freedomaim = P_SpawnMobjFromMobj(mo, mo.x+mo.momx, mo.y+mo.momy, mo.z, MT_THOK)
			freedomaim.color = mo.color
			freedomaim.scale = mo.scale/2
			freedomaim.tics = 2
			freedomaim.angle = mo.angle
			freedomaim.momx = mo.momx
			freedomaim.momy = mo.momy
			freedomaim.frame = freedomaim.frame|FF_TRANS70
			
			local dist = 7*i
			local vangle = cos(mo.player.aiming)*P_MobjFlip(mo)
			
			local x = mo.x + FixedMul(dist * cos(mo.angle), vangle)
			local y = mo.y + FixedMul(dist * sin(mo.angle), vangle)
			local z = mo.z + GetFlippedZ(mo) + dist * sin(mo.player.aiming)
			P_SetOrigin(freedomaim, x, y, z)
		end
		
		
	end
end

local function ShouldResetFreedomDash(mo)
	if P_IsObjectOnGround(mo)
	or P_PlayerInPain(mo.player)
	or mo.player.powers[pw_carry]
	or mo.player.pflags & PF_STASIS
	or mo.player.pflags & PF_FULLSTASIS
	or mo.player.exiting
	or mo.state == S_PLAY_FALL
	or mo.state == S_PLAY_SPRING
		return true
	end
end

local function ResetFreedomDash(p)
	p.usable = true
	p.charging = false
	//p.mo.flags = $ & ~MF_NOGRAVITY
	p.rev = 0
	if p.revaiming ~= 0
		p.revaiming = 0
		if p.freeaim == 0
			p.aiming = 0
		end
	end
	p.olddashmode = 0
	p.olddashspeed = 0
	if p.resetanalog and p.resetanalog == true
		p.pflags = $|PF_ANALOGMODE
		p.resetanalog = false
	end
end

local function RegainDashmode(p)
	if p.olddashmode > 0
		p.toeidashmode = p.olddashmode
		p.normalspeed = p.olddashspeed
		p.olddashmode = 0
		//S_StartSound(p.mo, sfx_cdfm40)
	end
end

addHook("PlayerThink", function(p)
	if not p.mo return end
	if p.mo.skin != "juniosonic" return end
	if p.playerstate == PST_DEAD return end
	p.charability = CA_NONE
	
	if not (p.cmd.buttons & BT_USE) 
	and not (p.cmd.buttons & BT_JUMP)
		p.recurlheld = false
	end
	if P_IsObjectOnGround(p.mo)
	or p.powers[pw_justsprung]
		if(p.cmd.buttons & BT_USE or p.cmd.buttons & BT_JUMP)
			p.recurlheld = true
		end
		p.recurled = false
	end
	if p.pflags & PF_STARTJUMP
	and (p.cmd.buttons & BT_USE or p.cmd.buttons & BT_JUMP)
		p.recurlheld = true
	end
	if (p.pflags == p.pflags & ~(PF_JUMPED|PF_SPINNING|PF_THOKKED))
	and not (P_PlayerInPain(p))
	and not (p.powers[pw_super] > 0 and p.powers[pw_super] < 25)
	and not (P_IsObjectOnGround(p.mo))
	and not (p.powers[pw_carry])
	and p.playerstate == PST_LIVE
	and not (p.powers[pw_nocontrol])
		if ((p.mo.state == S_PLAY_STND)
		or (p.mo.state == S_PLAY_WAIT)
		or (p.mo.state == S_PLAY_WALK)
		or (p.mo.state == S_PLAY_RUN)
		or (p.mo.state == S_PLAY_DASH)) 
			p.mo.state = S_PLAY_SPRING
		end
		if (p.cmd.buttons & BT_USE or p.cmd.buttons & BT_JUMP)
		and p.recurlheld == false
		and p.recurled == false
			p.pflags = $1|PF_JUMPED
			p.mo.state = S_PLAY_JUMP
			S_StartSound(p.mo, sfx_tcurl)
			if p.powers[pw_super]
				p.usable = true
			else
				p.usable= false
			end
			p.recurlheld = true
			p.recurled = true
		end
	end
	p.rev = $ or 0
	p.revaiming = $ or 0
	if p.rev > 0
	and not ShouldResetFreedomDash(p.mo) 
		if not (p.mo.state >= S_PLAY_ROLL1_1 and p.mo.state <= S_PLAY_ROLL4_4)
		and not (p.mo.state == S_PLAY_FALL)
		and not (p.mo.state == S_PLAY_SPRING)
			p.mo.state = S_PLAY_ROLL1_1
		end
		
	end
	if ShouldResetFreedomDash(p.mo) 
		ResetFreedomDash(p)
	end
	if P_IsObjectOnGround(p.mo)
	and (p.mo.state >= S_PLAY_ROLL1_1 and p.mo.state <= S_PLAY_ROLL4_4)
		p.mo.state = S_PLAY_WALK
		p.pflags = $1 & ~PF_JUMPED
	end
	if p.rev and (not (p.cmd.buttons & BT_JUMP) or p.rev >= 6*TICRATE/5)
		local rev = p.rev + 10
		if p.freeaim == 0
			local vangle = cos(FixedAngle(p.revaiming))
			if p.mo.eflags & MFE_UNDERWATER
				p.mo.momx = FixedMul(rev/2 * cos(p.mo.angle), vangle)
				p.mo.momy = FixedMul(rev/2 * sin(p.mo.angle), vangle)
				p.mo.momz = rev*2/5/2 * sin(FixedAngle(p.revaiming))
			else
				p.mo.momx = FixedMul(rev * cos(p.mo.angle), vangle)
				p.mo.momy = FixedMul(rev * sin(p.mo.angle), vangle) 
				p.mo.momz = rev*2/4 * sin(FixedAngle(p.revaiming))
			end
			p.aiming = 0
		else
			local vangle = cos(p.aiming)
			if p.mo.eflags & MFE_UNDERWATER
				p.mo.momx = FixedMul(rev/2 * cos(p.mo.angle), vangle)
				p.mo.momy = FixedMul(rev/2 * sin(p.mo.angle), vangle)
				p.mo.momz = rev*2/5/2 * sin(p.aiming)
			else
				p.mo.momx = FixedMul(rev * cos(p.mo.angle), vangle)
				p.mo.momy = FixedMul(rev * sin(p.mo.angle), vangle) 
				p.mo.momz = rev*2/4 * sin(p.aiming)
			end
			
		end
		if p.resetanalog and p.resetanalog == true
			p.pflags = $|PF_ANALOGMODE
			p.resetanalog = false
		end
		S_StartSound(p.mo, sfx_tdash)
		//p.mo.flags = $ & ~MF_NOGRAVITY
		p.charging = false
		if p.olddashmode > 0
			RegainDashmode(p)
		end
		p.rev = 0
		P_SpawnGhostMobj(p.mo)
	end
end)

addHook("AbilitySpecial", function(p)
	if not p.mo return end
	if p.mo.skin != "juniosonic" return end
	if p.pflags & PF_THOKKED
	or p.pflags & PF_SHIELDABILITY
		return
	end
	if p.usable
		p.charging = true
		p.rev = 0
		p.revaiming = 0
		p.usable = false
		p.recurlheld = true
		if p.toeidashmode
			p.olddashmode = p.toeidashmode
			p.olddashspeed = p.normalspeed
		end
		S_StartSound(p.mo, sfx_spnwnd)
	end
end)

addHook("JumpSpecial", function(p)
	if not p.mo return end
	if p.mo.skin != "juniosonic" return end
	if not p.charging return end
	if P_PlayerInPain(p) return end
	if p.pflags & PF_STASIS 
	or p.pflags & PF_FULLSTASIS
	or p.pflags & PF_SHIELDABILITY
	or p.mo.state == S_PLAY_SPRING
	or p.mo.state == S_PLAY_FALL
		return
	end
	
	//p.mo.flags = $ | MF_NOGRAVITY
	p.pflags = $ & ~PF_SPINNING
	p.pflags = $ | PF_THOKKED
	
	
	p.mo.momz = 0
	if p.pflags & PF_ANALOGMODE
		p.resetanalog = true
		p.pflags = $ & ~PF_ANALOGMODE
	end
	p.drawangle = p.mo.angle
	if p.freeaim == 0
		if p.invertedaim == 1
			p.revaiming = $ - p.cmd.forwardmove*P_MobjFlip(p.mo) * FRACUNIT/8
		else
			p.revaiming = $ + p.cmd.forwardmove*P_MobjFlip(p.mo) * FRACUNIT/8
		end
		p.revaiming = min($, 90*FRACUNIT)
		p.revaiming = max($, -90*FRACUNIT)
		if (p.mo.flags2 & MF2_TWOD)
		or twodlevel
			p.aiming = FixedAngle(p.revaiming/3)
		else
			p.aiming = FixedAngle(p.revaiming/2)
			p.mo.angle = $ - p.cmd.sidemove * FRACUNIT * 32
		end
	end
	if p.speed > FixedMul(3*FRACUNIT, p.mo.scale)
		local speed = FixedHypot(p.mo.momx,p.mo.momy)
		if speed > p.mo.scale then
			local dir = R_PointToAngle2(0,0,p.mo.momx,p.mo.momy)
			P_InstaThrust(p.mo,dir,speed-p.mo.scale*(p.speed > FixedMul(75*FRACUNIT, p.mo.scale) and 4 or p.speed > FixedMul(50*FRACUNIT, p.mo.scale) and 3 or 2))
		end
	elseif p.speed <= FixedMul(3*FRACUNIT, p.mo.scale)
		p.mo.momx = 0
		p.mo.momy = 0
	end
	SpawnDashAim(p.mo)
	
	if p.speed < FixedMul(p.normalspeed, p.mo.scale)
		p.rev = $ + 1
	end
end)

addHook("MobjDeath", function(enemy, freedom, freedom)
	if (freedom and freedom.valid and freedom.skin == "juniosonic")
		if (enemy and enemy.valid and not (enemy.flags & MF_BOSS))
		and (enemy.flags & MF_ENEMY or enemy.flags & MF_MONITOR)
			if (freedom.player.usable == false)
			and freedom.player.charging == false
				freedom.player.usable = true
				freedom.player.pflags = $1 & ~PF_THOKKED
			end
		end
		return false
	end
end)